"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports.Format = void 0;

var _from = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/from"));

var _defineProperty = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _keys3 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/typeof"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/is-array"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/applyDecoratedDescriptor"));

var _formatter = require("./formatter");

var _mobx = require("mobx");

var _class;

var Format = (_class = /*#__PURE__*/function () {
  function Format(name, format, defaultValue) {
    (0, _classCallCheck2.default)(this, Format);
    this.name = name;
    this.format = format;
    this.defaultValue = defaultValue;
  }

  (0, _createClass2.default)(Format, [{
    key: "deserializeValue",
    value: function deserializeValue(format, state, context, getSelf) {
      if (!format) {
        return typeof state === 'undefined' ? format : state;
      }

      if (state && state.isModel) {
        state = state.serialize();
      }

      if (format instanceof Format) {
        return format.deserialize(state, context, getSelf);
      } else if (format && format.isModelType) {
        return _formatter.formatter.model(format).deserialize(state || format, context, getSelf);
      } else if ((0, _isArray.default)(format)) {
        return _formatter.formatter.array(null).deserialize(state || format, context, getSelf);
      } else if ((0, _typeof2.default)(format) === 'object') {
        return _formatter.formatter.schema(format).deserialize(state, context, function () {
          return getSelf() || {};
        });
      } else {
        return _formatter.formatter.ref(null).deserialize(typeof state === 'undefined' ? format : state, context, getSelf);
      }
    }
  }, {
    key: "deserialize",
    value: function deserialize(state, context, getSelf) {
      var _this = this;

      switch (this.name) {
        case 'schema':
          {
            state = state || this.defaultValue || {};
            var keys = (0, _keys3.default)(this.format);
            var result = keys.reduce(function (object, key) {
              if (object.hasOwnProperty(key) && (0, _getOwnPropertyDescriptor.default)(object, key).get) {
                object[key] = state[key]; // object[key] = this.deserializeValue(this.format[key], state[key] /* || object[key] */, context, () => object[key])
              } else {
                var value;
                (0, _defineProperty.default)(object, key, {
                  get: function get() {
                    return value && value.get();
                  },
                  set: function set(newValue) {
                    value.set(_this.deserializeValue(_this.format[key], newValue
                    /* || object[key] */
                    , context, function () {
                      return object[key];
                    }));
                  },
                  enumerable: true,
                  configurable: false
                });
                value = _mobx.observable.box(_this.deserializeValue(_this.format[key], state[key], context, function () {
                  return object[key];
                }), {
                  deep: false
                });
                (0, _defineProperty.default)(object, key + '$', {
                  value: value,
                  enumerable: false,
                  configurable: false
                });
              }

              return object;
            }, getSelf());
            return result;
          }

        case 'model':
          {
            state = state || this.defaultValue || state;
            var ModelClass = this.format;
            return new ModelClass(state, context);
          }

        case 'private':
        case 'ref':
          {
            state = state || this.defaultValue || state;
            return this.deserializeValue(this.format, state, context, getSelf);
          }

        case 'array':
          {
            state = state || this.defaultValue || [];

            var object = _mobx.observable.array(state.reduce(function (object, item, index) {
              object[index] = _this.deserializeValue(_this.format, item, context, function () {
                return object[index];
              });
              return object;
            }, []), {
              deep: false
            });

            (0, _mobx.intercept)(object, function (change) {
              if (change.type === 'update') {
                change.newValue = _this.deserializeValue(_this.format, change.newValue, context, function () {
                  return object[change.index];
                });
              } else if (change.type === 'splice') {
                change.added = change.added.map(function (item) {
                  // return this.deserializeValue(this.format, item, context, () => (((change.index + increment) < object.length) ? object[change.index + increment] : null))
                  return _this.deserializeValue(_this.format, item, context, function () {
                    return null;
                  });
                });
              }

              return change;
            });
            return object;
          }

        case 'map':
          {
            state = state || this.defaultValue || {};

            var _keys = (0, _keys3.default)(state);

            var _object = _mobx.observable.map(_keys.reduce(function (object, key) {
              object[key] = _this.deserializeValue(_this.format, state[key], context, function () {
                return object[key];
              });
              return object;
            }, {}), {
              deep: false
            });

            (0, _mobx.intercept)(_object, function (change) {
              if (change.type === 'add' || change.type === 'update') {
                change.newValue = _this.deserializeValue(_this.format, change.newValue, context, function () {
                  return _object.get(change.name);
                });
              }

              return change;
            });
            return _object;
          }

        case 'deep':
          {
            state = state || this.defaultValue || null;
            return (0, _mobx.observable)(state);
          }

        case 'deepArray':
          {
            state = state || this.defaultValue || [];
            return _mobx.observable.array(state);
          }

        case 'deepMap':
          {
            state = state || this.defaultValue || [];
            return _mobx.observable.map(state);
          }

        default:
          {
            throw new Error("Unknown format '".concat(this.name, "'"));
          }
      }
    }
  }, {
    key: "serializeValue",
    value: function serializeValue(format, object) {
      if (!format) {
        return object;
      } else if (format instanceof Format) {
        return format.serialize(object);
      } else if (format.isModelType) {
        return _formatter.formatter.model(format).serialize(object);
      } else if ((0, _isArray.default)(format)) {
        return _formatter.formatter.array(null).serialize(object);
      } else if ((0, _typeof2.default)(format) === 'object') {
        return _formatter.formatter.schema(format).serialize(object);
      } else {
        return _formatter.formatter.ref(null).serialize(object);
      }
    }
  }, {
    key: "serialize",
    value: function serialize(object) {
      var _this2 = this;

      if (!object) {
        return object;
      }

      switch (this.name) {
        case 'schema':
          {
            var keys = (0, _keys3.default)(this.format);
            return keys.reduce(function (result, key) {
              if (_this2.format[key] && _this2.format[key].name === 'private') {
                return result;
              } else {
                result[key] = _this2.serializeValue(_this2.format[key], object[key]);
                return result;
              }
            }, {});
          }

        case 'model':
          {
            return object.serialize();
          }

        case 'ref':
          {
            return object;
          }

        case 'array':
          {
            return object.map(function (item) {
              return _this2.serializeValue(_this2.format, item);
            });
          }

        case 'map':
          {
            var _keys2 = (0, _from.default)(object.keys());

            return _keys2.reduce(function (result, key) {
              result[key] = _this2.serializeValue(_this2.format, object.get(key));
              return result;
            }, {});
          }

        case 'deep':
        case 'deepArray':
        case 'deepMap':
          {
            return (0, _mobx.toJS)(object);
          }

        default:
          {
            throw new Error("Unknown format '".concat(this.name, "'"));
          }
      }
    }
  }, {
    key: "isFormat",
    get: function get() {
      return true;
    }
  }]);
  return Format;
}(), ((0, _applyDecoratedDescriptor2.default)(_class.prototype, "deserialize", [_mobx.action], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "deserialize"), _class.prototype)), _class);
exports.Format = Format;