"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports.Models = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/json/stringify"));

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/slicedToArray"));

var _from = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/from"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/map"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _registrar = require("./registrar");

var _frontfulUtils = require("frontful-utils");

function ownKeys(object, enumerableOnly) { var keys = (0, _keys.default)(object); if (_getOwnPropertySymbols.default) { var symbols = (0, _getOwnPropertySymbols.default)(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor.default)(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty3.default)(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors.default) { (0, _defineProperties.default)(target, (0, _getOwnPropertyDescriptors.default)(source)); } else { ownKeys(Object(source)).forEach(function (key) { (0, _defineProperty2.default)(target, key, (0, _getOwnPropertyDescriptor.default)(source, key)); }); } } return target; }

var Models = /*#__PURE__*/function () {
  function Models(dependencies) {
    (0, _classCallCheck2.default)(this, Models);
    this.dependencies = dependencies;
    this.models = new _map.default();
    this.data = {};
    this.context = _objectSpread({}, this.dependencies, {
      models: this
    });

    if ((0, _frontfulUtils.isBrowser)() && window.frontful && window.frontful.model && window.frontful.model.state) {
      this.deserialize(window.frontful.model.state);
    }
  }

  (0, _createClass2.default)(Models, [{
    key: "global",
    value: function global() {
      var key, Type, data;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (typeof args[0] === 'string') {
        key = args[0];
        Type = args[1];
        data = args[2];

        if (!_registrar.registrar.Types[key]) {
          _registrar.registrar.register(key, Type);
        }
      } else if (args[0]) {
        Type = args[0];
        data = args[1];
        key = Type.identifier;
      } else {
        Type = args[1];
        data = args[2];
        key = Type.identifier;
      }

      if (!key) {
        console.warn('Missing model identifier');
      }

      if (this.models.has(key)) {
        return this.models.get(key);
      } else {
        var model = new Type('deferred');
        this.models.set(key, model);
        model.initializer(this.data[key] || data, _objectSpread({}, this.context, {
          name: key
        }));
        delete this.data[key];
        return model;
      }
    }
  }, {
    key: "serialize",
    value: function serialize() {
      return (0, _from.default)(this.models.entries()).reduce(function (result, _ref) {
        var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        result[key] = value.serialize();
        return result;
      }, {});
    }
  }, {
    key: "deserialize",
    value: function deserialize(data) {
      var _this = this;

      this.data = (0, _extends2.default)({}, data);

      _registrar.registrar.keys.forEach(function (key) {
        if (_this.data[key]) {
          var model = new _registrar.registrar.Types[key]('deferred');

          _this.models.set(key, model);

          model.initializer(data[key], _objectSpread({}, _this.context, {
            name: key
          }));
          delete _this.data[key];
        }
      });
    }
  }, {
    key: "renderToString",
    value: function renderToString() {
      return "<script>window.frontful = window.frontful || {};window.frontful.model = window.frontful.model || {};window.frontful.model.state = ".concat((0, _stringify.default)(this.serialize(), null, 2), ";</script>");
    }
  }]);
  return Models;
}();

exports.Models = Models;