"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.formatter = formatter;

var _Format = require("./Format");

function formatter(format) {
  return formatter.schema(format);
}

formatter.private = function (format) {
  return new _Format.Format('private', format, null);
};

formatter.schema = function (format) {
  return new _Format.Format('schema', format, null);
};

formatter.model = function (format, defaultValue) {
  return new _Format.Format('model', format, defaultValue || null);
};

formatter.ref = function (format, defaultValue) {
  return new _Format.Format('ref', format, defaultValue || null);
};

formatter.array = function (format, defaultValue) {
  return new _Format.Format('array', format, defaultValue || null);
};

formatter.map = function (format, defaultValue) {
  return new _Format.Format('map', format, defaultValue || null);
};

formatter.deep = function (defaultValue) {
  return new _Format.Format('deep', null, defaultValue || {});
};

formatter.deepArray = function (defaultValue) {
  return new _Format.Format('deepArray', null, defaultValue || null);
};

formatter.deepMap = function (defaultValue) {
  return new _Format.Format('deepMap', null, defaultValue || null);
};