"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.model = model;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _setPrototypeOf = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/set-prototype-of"));

var _create = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/create"));

var _formatter = require("./formatter");

var _deepExtend = _interopRequireDefault(require("deep-extend"));

var _registrar = require("./registrar");

var _mobx = require("mobx");

function model(format, identifier) {
  return model.format(format, identifier);
}

model.define = function (definer) {
  return function (Model) {
    Model.__model_definer__ = definer;
    return Model;
  };
};

model.format = function (format, identifier) {
  if (!format.isFormat) {
    format = _formatter.formatter.schema(format);
  }

  return function (Type) {
    function Model(data, context) {
      if (data !== 'deferred') {
        Model.prototype.initializer.call(this, data, context);
      }
    }

    if (identifier) {
      _registrar.registrar.register(identifier, Model);
    } else {
      _registrar.registrar.register(Model);
    }

    Model.isModelType = true;
    Model.prototype = (0, _create.default)(Type.prototype);
    (0, _setPrototypeOf.default)(Model, Type);
    Model.prototype.constructor = Model;

    Model.prototype.initializer = function (data, context) {
      if (context) {
        this.context = context;

        if (Model.__model_definer__) {
          (0, _extends2.default)(this, Model.__model_definer__.call(this, context));
        }
      } else {
        console.warn('Missing `context` argument');
      }

      Model.prototype.deserialize.call(this, data);
      Type.call(this, data, this.context);
    };

    Model.prototype.isModel = true;
    Model.prototype.deserialize = (0, _mobx.action)(function (data) {
      var _this = this;

      format.deserialize(data, this.context, function () {
        return _this;
      });
    });

    Model.prototype.serialize = function () {
      if (Type.isModelType) {
        return (0, _deepExtend.default)(Type.prototype.serialize.call(this), format.serialize(this));
      } else {
        return format.serialize(this);
      }
    };

    return Model;
  };
};

model.reset = function () {
  _registrar.registrar.reset();
};